import java.io.*;
import java.lang.*;
import java.util.Vector;
import java.util.StringTokenizer;

/* This class  */

public class RegionLabelData implements Serializable
{
    static final long serialVersionUID=-2805284943658356093L; // avoid version problem;

    private String imageFilePath = "";
    private String segmentFilePath = "";
 //   private  int activeSegment = 0;
 //   private  int numSegments = 0;
    private Vector<Object> labels = new Vector<Object>();

    RegionLabelData()
    {
    }
 
    RegionLabelData(int num)
    {
        this("", "", num);
    } 
    RegionLabelData(String imgPath, String segPath)
    {
        this(imgPath, segPath, 0);
    }
    
    RegionLabelData(String imgPath, String segPath , int num)
    {
        setImageFilePath(imgPath);
        setSegmentFilePath(segPath);
   //     numSegments = num;

        initializeLabels(num);
        // initialize labels as "Unknown"
      /*  for(int i=0; i<num; i++)
        {
            labels.add(new String("Unknown"));
        }*/
    }
    
    public void initializeLabels(int num)
    {
        // initialize labels as "unknown"
        for(int i=0; i<num; i++)
        {
            labels.add(new String("unknown"));
        }
    }

    public void setImageFilePath(String path)
    {
        imageFilePath = new String(path); 
    }

    public String getImageFilePath()
    {
        return imageFilePath;
    }
    
    public void setSegmentFilePath(String path)
    {
        segmentFilePath = new String(path); 
    }

    public String getSegmentFilePath()
    {
        return segmentFilePath;
    }

   /* public void setActiveSegment(int index)
    {
         if(index >= 0 && index < numSegments)
         {
             activeSegment = index;
         }
    }

    public int getActiveSegment()
    {
        return activeSegment;
    }*/

   /* public void setNumSegments(int num)
    {
        numSegments = num;
    } 

    public int getNumSegments()
    {
        return numSegments;
    }*/

    public void setLabels(Vector v)
    {
        labels = v;
       /* if(v != null) 
        {
            setNumSegments(v.size());
        }*/
    }

    public Vector getLabels()
    {
        return labels;
    }
    
 /*   public void setActiveSegmentLabel(String label)
    {
        setSegmentLabelAt(label, activeSegment);
    }*/

    public void setSegmentLabelAt(String label, int index)
    {
        if(labels != null)
        {
            labels.set(index, new String(label));
        }
    }
    
    public String getSegmentLabelAt(int index)
    {
        if(labels != null)
        {
            return (String)labels.get(index);
        }

        return null;
    }

    /* save as an object */
    public static boolean saveRegionLabelDataAsObject(RegionLabelData data, String fileName)
    {
        if(data == null)
        {
           //TODO: track error;
            return false;
        }

        try
        {
            ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream(fileName));
            out.writeObject(data);
            out.close();
        }
        catch(IOException e)
        {
           //TODO: track error;
            e.printStackTrace();
            return false;
        }


        return true;
    }
   
    /*read data from object file */ 
    public static RegionLabelData readRegionLabelDataFromObject(String fileName)
    {
        RegionLabelData data = null;

        try
        {
            ObjectInputStream in = new ObjectInputStream(new FileInputStream(fileName));
            data = (RegionLabelData)(in.readObject());
            in.close();
        }
        catch(Exception e)
        {
           //TODO: track error;
            e.printStackTrace();
            return null;
        }
        finally 
        {
            return data;
        }
    }

    /* Save data as text file. If 'all ' is true, then save everything in the object, otherwise,
       only the label data */
    public static boolean saveRegionLabelDataAsText(RegionLabelData data, String fileName, boolean all)
    {
        if(data == null)
        {
           //TODO: track error;
            return false;
        }

        try
        {
            PrintWriter out = new PrintWriter(new FileOutputStream(fileName));
            Vector v = data.getLabels(); 
            int size = v.size();

            if(all) {
                out.println("# image file");
                out.println(data.getImageFilePath());
                out.println("# segmentation file");
                out.println(data.getSegmentFilePath());
           
                out.println("# number of labels");
                out.println(size);
                out.println("# labels");
            }

            for(int i=0; i<size; i++)
            {
                String label = (String)v.get(i);
                out.println(label);
            }
            out.close();
        }
        catch(IOException e)
        {
           //TODO: track error;
            e.printStackTrace();
            return false;
        }

        return true;
    }
    
   /* Read data from text file.*/
    public static RegionLabelData readRegionLabelDataFromText(String fileName)
    {
        RegionLabelData data = new RegionLabelData();

        try
        {
            int next = 0;
            BufferedReader in = new BufferedReader(new FileReader(fileName));
            while(in.ready())
            {
                String line = in.readLine();
                StringTokenizer t = new StringTokenizer(line, "\n\r");
                String lineStr = t.nextToken(); 
                if(lineStr.startsWith("#"))
                {
                    next++;
                }
                else
                {
                    if(next == 1)
                        data.setImageFilePath(lineStr);
                    else if(next == 2)
                        data.setSegmentFilePath(lineStr);
                    else if(next == 3) // skip the number of labels;
                       ;
                    else if(next == 4)
                    {
                        data.getLabels().add(lineStr);
                    }
                }
                 
            }
            in.close();
        }
        catch(IOException e)
        {
           //TODO: track error;
            e.printStackTrace();
          //  return null;
        }
        finally
        {
            return data;
        }

    }

    public static void main(String[] args)
    {
       try{
        /*   RegionLabelData d = (RegionLabelData)readRegionLabelDataFromObject(args[0]);
           if(d != null)
               System.out.println(d.getImageFilePath());
           saveRegionLabelDataAsText(d, "test1.txt", true);*/
           RegionLabelData d1 = readRegionLabelDataFromText("test1.txt");
           saveRegionLabelDataAsText(d1, "test3.txt", true);
       }
       catch(Exception e){
           ;
       }
    }
}
