import java.io.Serializable;
import java.io.File;
import java.awt.Point;
import java.util.Vector;
import java.lang.String;
import java.io.IOException;
import java.io.FileInputStream;

public class SegmentLine implements Serializable
{
        //
    public int segmentIndex;
    public int y;
    public int x1;
    public int x2;
    
    SegmentLine(int aIndex, int aY, int aX1, int aX2)
    {
        segmentIndex = aIndex;
        y = aY;
        x1 = aX1;
        x2 = aX2;
    }

    public String toString()
    {
        String s = segmentIndex + " " + y + " " + x1 + " " + x2;
        return s;
    }

    public static Vector parseSegmentFile(File file) throws Exception
    {
        Vector v = null;
        try 
        {
            v = parseSegmentFile(file.getPath());
        }
        catch (Exception e)
        {
          throw e;
        }
        finally
        {
            return v;
        }
    }

    public static Vector parseSegmentFile(String fileName) throws Exception
    {
        
        TextReader input;
        try 
        {
            input = new TextReader(new FileInputStream(fileName));
        } 
        catch (IOException e)
        {
          throw new RuntimeException(e.toString());
        }

        boolean isData = false;
        boolean isNumOfSegments = false;
        int count = 0;
        int index=0;
        int segIndex = 0;
        int ypos = 0;
        int xpos1 = 0;
        int xpos2 = 0;
        Vector sline = null; 
        int numSegments = 0;
        while (input.ready())
        {
            if(!isData) 
            {
                if(isNumOfSegments)
                {
                    numSegments = input.readInt();
                    sline = new Vector();
                    isNumOfSegments = false;
                    System.out.println("# of segments: " + numSegments);
                }
                else 
                {
                    String s = input.readWord();
                    if(s.compareTo("data") == 0)
                    {
                        isData = true;
                    }
                    else if(s.compareTo("segments") == 0)
                    {
                        isNumOfSegments = true;
                    }
                } 
            } 
            else
            {
               int id = count % 4;
               if( id == 0)
               {
                   segIndex = input.readInt();
               }
               else if(id == 1)
               {
                   ypos = input.readInt();
               }
               else if(id == 2)
               {
                   xpos1 = input.readInt();
               }
               else if(id == 3)
               {
                   xpos2 = input.readInt();
               }
               
               count++; 

               if(count % 4 == 0) 
               {
            //       System.out.println(segIndex+" " + ypos + " " + xpos1 + " " + xpos2);
                   sline.add(new SegmentLine(segIndex, ypos, xpos1, xpos2));
               } 
            }
        }

        if(sline == null || sline.size() == 0)
        {
           throw new Exception("Invalid segment file!");
        }
 
        return sline;
    }

        
    public static void main(String[] args)
    {
       try{
           Vector v = parseSegmentFile(args[0]);
           for(int i=0; i<v.size(); i++) {
               System.out.println("-----" + i + "-----");
                System.out.println((SegmentLine)v.get(i));
           }
       }
       catch(Exception e){
           e.printStackTrace();
       }
    }
}
